import { setPath } from './../util';

describe('reshep > util > setPath', function () {
  test('Sets a shallow path.', function () {
    var path = ['a'];
    var value = true;
    var target = { b: false };

    var result = setPath(path, value, target);
    var expected = { a: true, b: false };

    expect(result).toEqual(expected);
  });

  test('Sets a deep path that doesn\'t exist.', function () {
    var path = ['a', 'b', 'c'];
    var value = true;
    var target = { b: false };

    var result = setPath(path, value, target);
    var expected = { a: { b: { c: true } }, b: false };

    expect(result).toEqual(expected);
  });

  test('Sets a deep path that does exist.', function () {
    var path = ['a', 'b', 'c'];
    var value = true;
    var target = { a: { b: { c: false, d: false } } };

    var result = setPath(path, value, target);
    var expected = { a: { b: { c: true, d: false } } };

    expect(result).toEqual(expected);
  });
});